-- name: [CS] Sugar Guy & Pizza Dude
-- description: sugary indeed....... / Model: sophietm__ Character: sam15_09

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
	(This is an edited version of the Template File by Squishy)
]]

local TEXT_MOD_NAME = "Sugar Guy"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_CUSTOM_MODEL = smlua_model_util_get_id("sugarman_geo")

local E_MODEL_PIZZADUDE = smlua_model_util_get_id("pizzadude_geo")

local TEX_CUSTOM_LIFE_ICON = get_texture_info("sweetindividual_icon") -- Located in "textures"

-- All Located in "sound" Name them whatever you want. Remember to include the .ogg extension
local VOICETABLE_SUGARGUY = {
    --[CHAR_SOUND_OKEY_DOKEY] = '', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Wall bonk
	[CHAR_SOUND_UH2] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Landing after long jump
	[CHAR_SOUND_UH2_2] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Landing triple jump
	[CHAR_SOUND_YAHOO] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Long jump
	[CHAR_SOUND_DOH] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Grabbing ledge
	[CHAR_SOUND_EEUH] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, 
	[CHAR_SOUND_HRMM] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'victory.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Damaged
	[CHAR_SOUND_PANTING] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Low health
	[CHAR_SOUND_ON_FIRE] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Snore Inhale
	[CHAR_SOUND_SNORING2] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Exhale
	[CHAR_SOUND_SNORING3] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Cough take 1
	[CHAR_SOUND_COUGHING2] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Cough take 2
	[CHAR_SOUND_COUGHING3] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'}, -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = {'loud_warning.ogg', 'michaelP.ogg', 'skull.ogg', 'blyat.ogg'}, -- Dying from damage
	[CHAR_SOUND_DROWNING] = {'loud_warning.ogg', 'michaelP.ogg', 'skull.ogg', 'blyat.ogg'}, -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = {'fufufuck.ogg', 'you fucking dick.ogg', 'fuck.ogg', 'fuck you.ogg', 'fucking dick.ogg', 'dick.ogg', 'shit.ogg', 'you piece of shit.ogg'} -- Booted out of level
}

-- All Located in "actors"
local CAPTABLE_CHAR = {
    normal = smlua_model_util_get_id("sugarmanhat_geo"),
    wing = smlua_model_util_get_id("sugarmanwingy_geo"),
    metal = smlua_model_util_get_id("sugarmanhatmetal_geo"),
}

local PALETTE_CHAR = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "F8DFC9FF",
    [GLOVES] = "ffffff",
    [SHOES]  = "ffffff",
    [HAIR]   = "ffffff",
    [SKIN]   = "F1BF8DFF",
    [CAP]    = "ffffff",
	[EMBLEM] = "ffffff"
}

local HM_SUGARGUY= {
    label = {
        left = get_texture_info("sugary_health1"),
        right = get_texture_info("sugary_health2"),
    },
 pie = {
        [1] = get_texture_info("sugary_indicator8"),
        [2] = get_texture_info("sugary_indicator7"),
        [3] = get_texture_info("sugary_indicator6"),
        [4] = get_texture_info("sugary_indicator5"),
        [5] = get_texture_info("sugary_indicator4"),
        [6] = get_texture_info("sugary_indicator3"),
        [7] = get_texture_info("sugary_indicator2"),
        [8] = get_texture_info("sugary_indicator1"),
    }
}

local CSloaded = false
local function on_character_select_load()
    CT_SUGARGUY = _G.charSelect.character_add("Sugar Guy", {"there is sugar", "in this guy !!!"}, "sophietm__", {r = 248, g = 223, b = 201}, E_MODEL_CUSTOM_MODEL, CT_SUGARGUY, TEX_CUSTOM_LIFE_ICON)
   
     _G.charSelect.character_add_caps(E_MODEL_CUSTOM_MODEL, CAPTABLE_CHAR)
     _G.charSelect.character_add_caps(E_MODEL_PIZZADUDE, CAPTABLE_CHAR)

    _G.charSelect.character_add_voice(E_MODEL_CUSTOM_MODEL, VOICETABLE_SUGARGUY)
    _G.charSelect.character_add_voice(E_MODEL_PIZZADUDE, VOICETABLE_SUGARGUY)


    _G.charSelect.character_add_celebration_star(E_MODEL_CUSTOM_MODEL, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_PIZZADUDE, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)

    _G.charSelect.character_add_palette_preset(E_MODEL_CUSTOM_MODEL, PALETTE_CHAR)
    _G.charSelect.character_add_palette_preset(E_MODEL_PIZZADUDE, PALETTE_CHAR)

    _G.charSelect.character_add_health_meter(CT_SUGARGUY, HM_SUGARGUY)
    _G.charSelect.character_add_health_meter(CT_SUGARGUY, HM_SUGARGUY)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SUGARGUY then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SUGARGUY then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)

-- Alt Costume Code (All credits to Wibblus!)

local CUR_SKIN_SUGARGUY = 1
-- table of skins
local SKINTABLE_SUGARGUY = {
    { model = E_MODEL_CUSTOM_MODEL,  name = "Sugar Guy", desc = "there's sugar in this guy!", credit = "sophietm__", color = {r = 248, g = 223, b = 201}, E_MODEL_CUSTOM_MODEL, CT_SUGARGUY, TEX_CUSTOM_LIFE_ICON},
    { model = E_MODEL_PIZZADUDE,  name = "Pizza Dude", desc = "there's pizza in this dude!", credit = "sophietm__", color = {r = 134, g = 159, b = 183}, E_MODEL_PIZZADUDE, CT_SUGARGUY, TEX_CUSTOM_LIFE_ICON},
}

local function update_character_skin()
    local curSugarSkin = SKINTABLE_SUGARGUY[CUR_SKIN_SUGARGUY]
    _G.charSelect.character_edit(CT_SUGARGUY, curSugarSkin.name, curSugarSkin.desc, curSugarSkin.credit, curSugarSkin.color, curSugarSkin.model, nil, curSugarSkin[6], nil)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_SUGARGUY then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_SUGARGUY < #SKINTABLE_SUGARGUY then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_SUGARGUY = CUR_SKIN_SUGARGUY + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_SUGARGUY > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_SUGARGUY = math.max(CUR_SKIN_SUGARGUY - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)